Project (Gradle API 7.6.4)

Package org.gradle.plugins.ide.idea.model

## Class Project

- java.lang.Object
- - org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject
  - - org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject
    - - org.gradle.plugins.ide.idea.model.Project

- All Implemented Interfaces:
    `org.gradle.plugins.ide.internal.generator.generator.PersistableConfigurationObject`

      public class Project
      extends org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject

  Represents the customizable elements of an ipr (via XML hooks everything of the ipr is customizable).

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Project​(org.gradle.internal.xml.XmlTransformer xmlTransformer, java.lang.Object pathFactory)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addModulePath​(java.io.File moduleFile)` | Adds a module to the module paths included in the Project.
    `void` | `configure​(java.util.List<IdeaModule> modules, java.lang.String jdkName, IdeaLanguageLevel languageLevel, JavaVersion bytecodeVersion, java.util.Collection<java.lang.String> wildcards, java.util.Collection<ProjectLibrary> projectLibraries, java.lang.String vcs)` |
    `boolean` | `equals​(java.lang.Object o)` |
    `protected java.lang.String` | `getDefaultResourceName()` |
    `Jdk` | `getJdk()` | Represent the jdk information of the project java sdk.
    `java.util.Set<Path>` | `getModulePaths()` | A set of `Path` instances pointing to the modules contained in the ipr.
    `java.util.Set<ProjectLibrary>` | `getProjectLibraries()` | The project-level libraries of the IDEA project.
    `java.lang.String` | `getVcs()` | The vcs used by the project.
    `java.util.Set<java.lang.String>` | `getWildcards()` | A set of wildcard string to be included/excluded from the resources.
    `int` | `hashCode()` |
    `protected void` | `load​(Node xml)` |
    `void` | `setJdk​(Jdk jdk)` |
    `void` | `setModulePaths​(java.util.Set<Path> modulePaths)` |
    `void` | `setProjectLibraries​(java.util.Set<ProjectLibrary> projectLibraries)` |
    `void` | `setVcs​(java.lang.String vcs)` |
    `void` | `setWildcards​(java.util.Set<java.lang.String> wildcards)` |
    `protected void` | `store​(Node xml)` |

    - ### Methods inherited from class org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject

      `findFirstChildNamed, findFirstChildWithAttributeValue, findFirstWithAttributeValue, findOrCreateFirstChildNamed, findOrCreateFirstChildWithAttributeValue, getChildren, getXml, load, store, transformAction, transformAction`

    - ### Methods inherited from class org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject

      `load, loadDefaults, store`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Project

          public Project​(org.gradle.internal.xml.XmlTransformer xmlTransformer,
                         java.lang.Object pathFactory)

  - ### Method Detail

    - #### getModulePaths

          public java.util.Set<Path> getModulePaths()

      A set of `Path` instances pointing to the modules contained in the ipr.

    - #### setModulePaths

          public void setModulePaths​(java.util.Set<Path> modulePaths)

    - #### addModulePath

          public void addModulePath​(java.io.File moduleFile)

      Adds a module to the module paths included in the Project.
      Parameters:
        `moduleFile` - path to the module's module file
      Since:
        4.0

    - #### getWildcards

          public java.util.Set<java.lang.String> getWildcards()

      A set of wildcard string to be included/excluded from the resources.

    - #### setWildcards

          public void setWildcards​(java.util.Set<java.lang.String> wildcards)

    - #### getJdk

          public Jdk getJdk()

      Represent the jdk information of the project java sdk.

    - #### setJdk

          public void setJdk​(Jdk jdk)

    - #### getVcs

          public java.lang.String getVcs()

      The vcs used by the project.

    - #### setVcs

          public void setVcs​(java.lang.String vcs)

    - #### getProjectLibraries

          public java.util.Set<ProjectLibrary> getProjectLibraries()

      The project-level libraries of the IDEA project.

    - #### setProjectLibraries

          public void setProjectLibraries​(java.util.Set<ProjectLibrary> projectLibraries)

    - #### getDefaultResourceName

          protected java.lang.String getDefaultResourceName()

      Specified by:
        `getDefaultResourceName` in class `org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject`

    - #### configure

          public void configure​(java.util.List<IdeaModule> modules,
                                java.lang.String jdkName,
                                IdeaLanguageLevel languageLevel,
                                JavaVersion bytecodeVersion,
                                java.util.Collection<java.lang.String> wildcards,
                                java.util.Collection<ProjectLibrary> projectLibraries,
                                java.lang.String vcs)

    - #### load

          protected void load​(Node xml)

      Overrides:
        `load` in class `org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject`

    - #### store

          protected void store​(Node xml)

      Overrides:
        `store` in class `org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject`

    - #### equals

          public boolean equals​(java.lang.Object o)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`